summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Johannes Schoepfer2024-04-19 16:56:47 +0200
committer Willy Sudiarto Raharjo2024-04-27 04:28:30 +0200
commit5c0008774d159e807d513dd1db6799cacbdec163 (patch)
tree7bfc7e054bdc198707be313e2c70c98b26126028
parentff84aa32301865ec5d9a86d1789cf03d0f914b66 (diff)
downloadslackbuilds-5c0008774d159e807d513dd1db6799cacbdec163.tar.gz
development/whisper.cpp: Added (OpenAI's Whisper model in C/C++).
Signed-off-by: Andrew Clemons <andrew.clemons@gmail.com> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/whisper.cpp/README16
-rw-r--r--development/whisper.cpp/slack-desc19
-rw-r--r--development/whisper.cpp/whisper.cpp.SlackBuild112
-rw-r--r--development/whisper.cpp/whisper.cpp.info10
4 files changed, 157 insertions, 0 deletions
diff --git a/development/whisper.cpp/README b/development/whisper.cpp/README
new file mode 100644
index 0000000000..2c0e887b33
--- /dev/null
+++ b/development/whisper.cpp/README
@@ -0,0 +1,16 @@
+High-performance inference of OpenAI's Whisper automatic speech
+recognition (ASR) model:
+
+ -Plain C/C++ implementation without dependencies
+ -Apple Silicon first-class citizen - optimized via ARM NEON,
+ Accelerate framework, Metal and Core ML
+ -AVX intrinsics support for x86 architectures
+ -VSX intrinsics support for POWER architectures
+ -Mixed F16 / F32 precision
+ -4-bit and 5-bit integer quantization support
+ -Zero memory allocations at runtime
+ -Support for CPU-only inference
+ -Efficient GPU support for NVIDIA
+ -Partial OpenCL GPU support via CLBlast
+ -OpenVINO Support
+ -C-style API
diff --git a/development/whisper.cpp/slack-desc b/development/whisper.cpp/slack-desc
new file mode 100644
index 0000000000..cb32483015
--- /dev/null
+++ b/development/whisper.cpp/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+whisper.cpp: whisper.cpp (Port of OpenAI's Whisper model in C/C++)
+whisper.cpp:
+whisper.cpp: High-performance inference of OpenAI's Whisper automatic speech
+whisper.cpp: recognition (ASR) model.
+whisper.cpp:
+whisper.cpp:
+whisper.cpp:
+whisper.cpp:
+whisper.cpp:
+whisper.cpp: https://github.com/ggerganov/whisper.cpp
+whisper.cpp:
diff --git a/development/whisper.cpp/whisper.cpp.SlackBuild b/development/whisper.cpp/whisper.cpp.SlackBuild
new file mode 100644
index 0000000000..07ed6b3518
--- /dev/null
+++ b/development/whisper.cpp/whisper.cpp.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/bash
+
+# Slackware build script for whisper.cpp
+
+# Copyright 2024 Johannes Schoepfer, Germany
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=whisper.cpp
+VERSION=${VERSION:-1.5.5}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "arm" ]; then
+ SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z
+cd $PRGNAM-$VERSION
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} + -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} +
+
+source /usr/share/openvino/setupvars.sh
+mkdir -p build
+cd build
+pwd
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DWHISPER_OPENVINO=ON \
+ -Wno-dev \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+[ "$ARCH" = "x86_64" ] && mv $PKG/usr/lib $PKG/usr/lib$LIBDIRSUFFIX
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS LICENSE README.md $PKG/usr/doc/$PRGNAM-$VERSION
+
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/whisper.cpp/whisper.cpp.info b/development/whisper.cpp/whisper.cpp.info
new file mode 100644
index 0000000000..3ba6af4afb
--- /dev/null
+++ b/development/whisper.cpp/whisper.cpp.info
@@ -0,0 +1,10 @@
+PRGNAM="whisper.cpp"
+VERSION="1.5.5"
+HOMEPAGE="https://github.com/ggerganov/whisper.cpp"
+DOWNLOAD="https://github.com/ggerganov/whisper.cpp/archive/v1.5.5/whisper.cpp-1.5.5.tar.gz"
+MD5SUM="a4c1d8283381a789c679d0b274ec6c64"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="openvino"
+MAINTAINER="Johannes Schoepfer"
+EMAIL="slackbuilds@schoepfer.info"